## Dynamically Stable Infinite-Width Limits of Neural Classifiers

This is the code to reproduce the result of the paper *"Dynamically Stable Infinite-Width Limits of Neural Classifiers"* submitted to ICLR'2021.

### Instructions:

First, perform computations:
* Main body:
  * Figures 1, right and 2:
    ```
    $ python fcnet_equiv_models_test.py --device=<cuda:0 or cpu> --num_hidden=1 --optimizer=sgd --lr=0.02 --num_epochs=2000 --dataset=cifar2_binary --train_size=1024 --batch_size=1024 --activation=lrelu --num_seeds=10
    ```
    ```
    $ python fcnet_equiv_models_test.py --device=<cuda:0 or cpu> --num_hidden=1 --optimizer=sgd --lr=0.02 --num_epochs=100 --dataset=cifar2_binary --train_size=1024 --batch_size=1024 --activation=lrelu --num_seeds=10 --track_tangent_kernels
    ```
* Supplementary material:
  * Figures 3-7:
    ```
    $ python fcnet_equiv_models_test.py --device=<cuda:0 or cpu> --num_hidden=1 --optimizer=sgd --lr=0.02 --num_epochs=500 --dataset=cifar2_binary --train_size=1024 --batch_size=256 --activation=lrelu --num_seeds=10
    ```
    ```
    $ python fcnet_equiv_models_test.py --device=<cuda:0 or cpu> --num_hidden=1 --optimizer=sgd --lr=0.02 --num_epochs=25 --dataset=cifar2_binary --train_size=1024 --batch_size=256 --activation=lrelu --num_seeds=10 --track_tangent_kernels
    ```
    ```
    $ python fcnet_equiv_models_test.py --device=<cuda:0 or cpu> --num_hidden=1 --optimizer=sgd --lr=0.02 --num_epochs=125 --dataset=cifar2_binary --train_size=1024 --batch_size=64 --activation=lrelu --num_seeds=10
    ```
    ```
    $ python fcnet_equiv_models_test.py --device=<cuda:0 or cpu> --num_hidden=1 --optimizer=sgd --lr=0.02 --num_epochs=6 --dataset=cifar2_binary --train_size=1024 --batch_size=64 --activation=lrelu --num_seeds=10 --track_tangent_kernels
    ```
    ```
    $ python fcnet_equiv_models_test.py --device=<cuda:0 or cpu> --num_hidden=1 --optimizer=sgd --lr=0.02 --num_epochs=125 --dataset=cifar2_binary --train_size=8192 --batch_size=512 --activation=lrelu --num_seeds=10
    ```
    ```
    $ python fcnet_equiv_models_test.py --device=<cuda:0 or cpu> --num_hidden=1 --optimizer=sgd --lr=0.02 --num_epochs=6 --dataset=cifar2_binary --train_size=8192 --batch_size=512 --activation=lrelu --num_seeds=10 --track_tangent_kernels
    ```

   
After performing computations, make plots by running cells in a notebook: [equiv_models_test.ipynb](/equiv_models_test.ipynb).
